
//
//  Obsolite code from version 1.0  I am just keeping this in case
//
#if 0

//
//  Convert JIS code into index into the kanji array.  This routine
//  does not check the validity of the JIS code.
//
//      jis    -- JIS code.
//
//      RETURN -- Index into the kanji data table.
//
static int kanji_index (int jis) {
  jis -= 0x3021;
  return ((jis >> 8)*94+(jis & 0xff));
}

//
//  Convert JIS code into index into the misc array.  This routine
//  does not check the validity of the JIS code.
//
//      jis    -- JIS code.
//
//      RETURN -- Index into the misc data table.
//
static int misc_index (int jis) {
  jis -= 0x2121;
  return ((jis >> 8)*94+(jis & 0xff));
}


//
//  Write the kanji data file.
//
//      name   -- Name of file to write.
//
//      REUTRN -- A non-zero return indicates an error.
//
int UTable::write_kanji (char *name) {
  FILE *file;
  int   i,j,start;
//
//  Find the highest kanji code value that has a kanji associated with it (this determins
//  the end of the table.
//
  for (i = 0; i < 10000; i++) {
    if (find(code_to_jis(i))) j = i;
  }
//
//  Initialize the file.
//
  printf ("Writing kanji unicode table [%s] ... ",name);
  if (!(file = fopen(name,"w"))) { printf ("\n\nCannot open database\n"); return (true); }
  write_head (file,"kanji");
  fprintf (file,"  ");                                  // File startup.
//
//  Write the table
//
  for (start = i = 0; i <= j; i++) {
    fprintf (file,"0x%4.4x,",find(code_to_jis(i)));     // Write entry.
    if (i && !((i+1) % 10)) {                           // Line breaks
      fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",code_to_jis(start),code_to_jis(i));
      start = i+1;
    }
  }
  fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",code_to_jis(start),code_to_jis(i-1));
//
//  Clean up.
//
  fclose (file);                                        // Finish up.
  printf ("done [%d kanji output]\n",j);
  return (false);
}

//
//  Write the symbol translation data file.
//
//      name   -- Name of data file to write.
//
//      RETURN -- Non-zero value indicates an error.
//
int UTable::write_misc (char *name) {
  FILE *file;
  int   i,j,start;
//
//  Find the highest kanji code value that has a kanji associated with it (this determins
//  the end of the table.
//
  for (i = 0; i < 10000; i++) {
    if (find(misc_to_jis(i))) j = i;
  }
//
//  Initialize the file.
//
  printf ("Writing kanji unicode table [%s] ... ",name);
  if (!(file = fopen(name,"w"))) { printf ("\n\nCannot open database\n"); return (true); }
  write_head (file,"kanji");
  fprintf (file,"  ");                                  // File startup.
//
//  Write the table
//
  for (start = i = 0; i <= j; i++) {
    fprintf (file,"0x%4.4x,",find(code_to_jis(i)));     // Write entry.
    if (i && !((i+1) % 10)) {                           // Line breaks
      fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",code_to_jis(start),code_to_jis(i));
      start = i+1;
    }
  }
  fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",code_to_jis(start),code_to_jis(i-1));
//
//  Clean up.
//
  fclose (file);                                        // Finish up.
  printf ("done [%d kanji output]\n",j);
  return (false);
}


//-------------------------------------------------------------------
//
//  High level process routines.
//

//
//  Read the unicode data file.
//
//      name   -- Name of unicode data file.
//  
//      RETURN -- A non-zero value indicates an error.
//
static int read_unicode (char *name) {
  int   i,jis,unicode;
  FILE *file;
  char buffer[500];
  printf ("Reading unicode data file [%s] ... ",name);
  if (!(file = fopen(name,"r"))) { printf ("\nCannot open datafile\n"); return (true); }
  memset (kanji,0,sizeof(kanji));                       // Clear data arrays
  memset (misc ,0,sizeof(misc ));
  for (i = 0; true; i++) {                              // i just counts lines.
    fgets (buffer,sizeof(buffer),file);                 // Get line.
    if (feof(file)) break;                              // EOF->done.
    if (buffer[0] == '#') continue;                     // comment line
    jis     = get_hex (buffer+9 );                      // Get jis and unicode values.
    unicode = get_hex (buffer+16);
    if (unicode == 0x301c) unicode = 0xff5e;            // Not actually standard, but machines MS usages (TrueType fonts)
    if ((jis >= 0x2100) && (jis < 0x2300)) {            // Process symbol characters.
      misc[misc_index(jis)] = unicode;
    }
    if ((jis >= 0x3000) && (jis < 0x7500)) {            // Process kanji characters
      kanji[kanji_index(jis)] = unicode;
    }
  }
  printf ("done [%d lines read]\n",i);                  // Done!
  fclose (file);
  return (false);
}

//
//  Write the kanji translation data file.
//
//      name   -- Name of data file to write.
//
//      RETURN -- Non-zero value indicates an error.
//
int write_kanji (char *name) {
  FILE *file;
  int   i,j,start;
  printf ("Writing kanji unicode table [%s] ... ",name);
  if (!(file = fopen(name,"w"))) { printf ("\nCannot open database\n"); return (true); }
  write_head (file,"kanji");
  for (j = NUMBER_KANJI-1; !kanji[j]; j--);             // Find number of entries.
  fprintf (file,"  ");                                  // File startup.
  for (start = i = 0; i <= j; i++) {
    fprintf (file,"0x%4.4x,",kanji[i]);                 // Write entry.
    if (i && !((i+1) % 10)) {                           // Line breaks
      fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",code_to_jis(start),code_to_jis(i));
      start = i+1;
    }
  }
  fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",code_to_jis(start),code_to_jis(i-1));
  fclose (file);                                        // Finish up.
  printf ("done [%d kanji output]\n",j);
  return (false);
  
}

//
//  Write the symbol translation data file.
//
//      name   -- Name of data file to write.
//
//      RETURN -- Non-zero value indicates an error.
//
int write_misc (char *name) {
  FILE *file;
  int   i,j,start;
  printf ("Writing symbol unicode table [%s] ... ",name);
  if (!(file = fopen(name,"w"))) { printf ("\nCannot open database\n"); return (true); }
  write_head (file,"symbol");
  for (j = NUMBER_MISC-1; !misc[j]; j--);               // Find number of entries.
  fprintf (file,"  ");                                  // File startup.
  for (start = i = 0; i <= j; i++) {
    fprintf (file,"0x%4.4x,",misc[i]);                  // Write entry.
    if (i && !((i+1) % 10)) {                           // Line breaks
      fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",misc_to_jis(start),misc_to_jis(i));
      start = i+1;
    }
  }
  fprintf (file,"  // 0x%4.4x..0x%4.4x\n  ",misc_to_jis(start),misc_to_jis(i-1));
  fclose (file);                                        // Finish up.
  printf ("done [%d characters output]\n",j);
  return (false);
  
}


//-----------------------------------------


#if 0       // Obsolite code
  if (read_unicode("JIS0208.TXT")) { printf ("Unable to read unicode data file\n"); exit (5); }
  if (write_kanji("jwp_ukan.dat")) { printf ("Unable to write kanji translate file\n"); exit (5); }
  if (write_misc ("jwp_umis.dat")) { printf ("Unable to write symbol translate file\n"); exit (5); }
#endif      // Obsolite code


#endif
